/*+
 *	Module:		lladvise.c
 *
 *	Purpose:	To advise the rest of the compiler as to the
 *			changes made to the source program by the
 *			error recovery process.
 *
 *	Invocation:	lladvise (code, line, insym, attptr, insert);
 *
 *	Parameters:
 *
 *	  Input:	code - An integer code indicating the nature of
 *			the advice being given.  1 means successful,
 *			while 2 means unsuccessful error correction.
 *
 *			line - The number of the line on which the error
 *			was found.
 *
 *			insym - The current input token.
 *
 *			attptr - The address of the attibutes of the
 *			current input token.
 *
 *			insert - The address of the string representing
 *			the tokens inserted by llrecover.
 *
 *	  Output:	None.
 *
 *	Author:		D. Bocking
 *
 *	Date:		12 December, 1984
-*/

#include	"llparam.h"
#include	"llglobal.h"
#include	<stdio.h>

lladvise (code, line, insym, attptr, insert)

int	code;
int	line;
int	insym;
int	attptr [];
char	*insert;

{
	char	*llprtoken ();

	switch (code) {

	case 1:		/* Symbol insertion */
		fprintf (stderr, "Inserted %s", insert);
		fprintf (stderr, "\nbefore %s on line %d.\n",
		llprtoken (insym, attptr), line);
		break;

	case 2:		/* Symbol deletion */
		fprintf (stderr, "Unrecoverable error on line %d at %s\n",
		line, llprtoken (insym, attptr));
		break;
	}
}
