/*+
 *	Module:		llprtoken.c
 *
 *	Purpose:	Provides the error recovery mechanism with
 *			a character string representation of a grammar
 *			token.
 *
 *	Invocation:	string = llprtoken (token, attrs);
 *
 *	Parameters:
 *
 *	  Input:	token - The integer representing the token for
 *			which the representative character string is to
 *			be created.
 *
 *			attrs - The address of the attributes of the
 *			token.
 *
 *	  Output:	string - The address of the representative character
 *			string.
 *
 *	Author:		D. Bocking
 *
 *	Date:		18 December, 1984
-*/

#include	"llglobal.h"
#include	<stdio.h>

char	*
llprtoken (token, attrs)

int	token;
int	attrs [];

{
	if (token < 0 || token >= llfnt) {
		fprintf (stderr, "Token %d out of range!\n", token);
		exit (1);
	}

	return (symbols [token]);
}
