/*+
 *	Module:		llstring.c
 *
 *	Purpose:	To provide subroutines for saving strings in
 *			static storage.
 *
 *	Invocation:	straddr = savstring (strng);
 *
 *	Parameters:
 *
 *	  Input:	strng - The address of the null-terminated
 *			character string to be saved.
 *
 *	  Output:	straddr - The address at which the argument
 *			string was stored.
 *
 *	Author:		D. Bocking
 *
 *	Date:		30 October, 1984
-*/

#include	"llparam.h"
#include	<stdio.h>
#include	"llglobal.h"

/*
 *	Storage for the saved strings and a pointer to the next available
 *	character slot.
 */

char	strspace [MAXSTR];
char	*strfree = strspace;

char	*
savstring (str)

char	*str;

{
	register	char	*base;
	register	int	length;

	length = strlen (str);
	if (&strfree [length + 1] >= &strspace [MAXSTR]) {
		fprintf (stderr, "%d String space overflow!\n", line);
		exit (1);
	}

	base = strfree;
	strcpy (strfree, str);
	strfree += length + 1;

	return (base);
}
