/*+
 *	Module:		llsymtab.h
 *
 *	Purpose:	Defines the structure of the internal tables
 *			used to store grammar symbols.
 *
 *	Invocation:	#include	"llsymtab.h"
 *
 *	Parameters:
 *
 *	  Input:	None.
 *
 *	  Output:	None.
 *
 *	Author:		D. Bocking
 *
 *	Date:		30 October, 1984
-*/

struct	symtab	{

	char	*sname;
	int	stype;
	int	snum;
	char	inherit;
	char	synth;
	struct	symtab	*chain;

};

/*
 *	Symbolic values for stype above.
 */

#define	SYMRHS	-1
#define	SYMLHS	-2
#define	SYMACT	-3
