/* Attributed Translation System Parsing Tables */

/* Symbolic Grammar Token Definitions */

#define	lleof	0
#define	RETURN	1
#define	PLUS	2
#define	MINUS	3
#define	MULT	4
#define	DIV	5
#define	NUMBER	6
#define	LP	7
#define	RP	8

/* The Grammar Symbol Name Table */

char *symbols[] = {
	"lleof",
	"RETURN",
	"PLUS",
	"MINUS",
	"MULT",
	"DIV",
	"NUMBER",
	"LP",
	"RP",
	"program",
	"expr",
	"term",
	"terms",
	"factor",
	"factors",
	"_evaltree",
	"_maknull",
	"_makplus",
	"_makminus",
	"_makmult",
	"_makdiv",
	"_maknumber",
};

/* Keys to the Grammar */

int	llfnt = 9;		/* First Non Terminal Symbol */
int	llfa  = 15;		/* First Action Symbol */
int	llfu  = 22;		/* First Unused Symbol */
int	llstart = 9;		/* Grammar Start Symbol */

/* Inherited and Synthesized Attribute Tables */

char llinhs [] = {
	0,0,0,0,0,0,0,0,0,0,
	0,0,1,0,1,1,1,2,2,2,
	2,1,
};

char llsyns [] = {
	0,0,0,0,0,0,1,0,0,0,
	1,1,1,1,1,0,1,1,1,1,
	1,1,
};

/* Action Routine Definitions and Addresses */

int	_evaltree();
int	_maknull();
int	_makplus();
int	_makminus();
int	_makmult();
int	_makdiv();
int	_maknumber();
int (*funct[])() = {
	_evaltree,
	_maknull,
	_makplus,
	_makminus,
	_makmult,
	_makdiv,
	_maknumber,
};

/* The Right Hand Side Table */

int llrhs [] = {
	
	10,-3,1,15,0,9,
	-5,11,-2,12,0,0,
	-3,-3,16,0,0,
	-6,-10,2,11,-3,17,0,0,-2,12,0,0,
	-6,-10,3,11,-3,18,0,0,-2,12,0,0,
	-5,13,-2,14,0,0,
	-3,-3,16,0,0,
	-6,-10,4,13,-3,19,0,0,-2,14,0,0,
	-6,-10,5,13,-3,20,0,0,-2,14,0,0,
	-5,6,-2,21,0,0,
	-3,7,10,0,8,
};

/* The Production Table */

int *llprod [] = {
	&llrhs [0],
	&llrhs [0],
	&llrhs [6],
	&llrhs [12],
	&llrhs [17],
	&llrhs [29],
	&llrhs [41],
	&llrhs [47],
	&llrhs [52],
	&llrhs [64],
	&llrhs [76],
	&llrhs [82],
	&llrhs [87]
};

/* The Parser Action Table */

int llpt[] = {

/* program */
	1, 0, 0, 0, 0, 0, 2, 2, 0, 

/* expr */
	0, 0, 0, 0, 0, 0, 3, 3, 0, 

/* term */
	0, 0, 0, 0, 0, 0, 7, 7, 0, 

/* terms */
	0, 4, 5, 6, 0, 0, 0, 0, 4, 

/* factor */
	0, 0, 0, 0, 0, 0, 11, 12, 0, 

/* factors */
	0, 8, 8, 8, 9, 10, 0, 0, 8, 
};

/* FMQ Error Recovery Tables */

/* Symbol Insertion Cost Table */

int llfmqcosts [] = {
	1,	/* lleof */
	1,	/* RETURN */
	1,	/* PLUS */
	1,	/* MINUS */
	1,	/* MULT */
	1,	/* DIV */
	1,	/* NUMBER */
	1,	/* LP */
	1,	/* RP */
	0,	/* program */
	1,	/* expr */
	1,	/* term */
	0,	/* terms */
	1,	/* factor */
	0,	/* factors */
};

/* Error String Token Table */

short llfmqstrngs [] = {

/* The Null String */
	-1,

/* S [lleof] */
 	0,-1,

/* S [RETURN] */
 	1,-1,

/* S [PLUS] */
 	2,-1,

/* S [MINUS] */
 	3,-1,

/* S [MULT] */
 	4,-1,

/* S [DIV] */
 	5,-1,

/* S [NUMBER] */
 	6,-1,

/* S [LP] */
 	7,-1,

/* S [RP] */
 	8,-1,

/* S [expr] */
 	6,-1,

/* S [term] */
 	6,-1,

/* S [factor] */
 	6,-1,

/* E [program, RETURN] */
 	6,-1,

/* E [program, PLUS] */
 	6,-1,

/* E [program, MINUS] */
 	6,-1,

/* E [program, MULT] */
 	6,-1,

/* E [program, DIV] */
 	6,-1,

/* E [program, RP] */
 	7,6,-1,

/* E [expr, PLUS] */
 	6,-1,

/* E [expr, MINUS] */
 	6,-1,

/* E [expr, MULT] */
 	6,-1,

/* E [expr, DIV] */
 	6,-1,

/* E [expr, RP] */
 	7,6,-1,

/* E [term, PLUS] */
 	7,6,-1,

/* E [term, MINUS] */
 	7,6,-1,

/* E [term, MULT] */
 	6,-1,

/* E [term, DIV] */
 	6,-1,

/* E [term, RP] */
 	7,6,-1,

/* E [terms, MULT] */
 	2,6,-1,

/* E [terms, DIV] */
 	2,6,-1,

/* E [terms, NUMBER] */
 	2,-1,

/* E [terms, LP] */
 	2,-1,

/* E [terms, RP] */
 	2,7,6,-1,

/* E [factor, PLUS] */
 	7,6,-1,

/* E [factor, MINUS] */
 	7,6,-1,

/* E [factor, MULT] */
 	7,6,-1,

/* E [factor, DIV] */
 	7,6,-1,

/* E [factor, RP] */
 	7,6,-1,

/* E [factors, PLUS] */
 	4,7,6,-1,

/* E [factors, MINUS] */
 	4,7,6,-1,

/* E [factors, NUMBER] */
 	4,-1,

/* E [factors, LP] */
 	4,-1,

/* E [factors, RP] */
 	4,7,6,-1,
};

/* Least Cost Terminal Strings */

short *llfmqS [] = {
	&llfmqstrngs [1],
	&llfmqstrngs [3],
	&llfmqstrngs [5],
	&llfmqstrngs [7],
	&llfmqstrngs [9],
	&llfmqstrngs [11],
	&llfmqstrngs [13],
	&llfmqstrngs [15],
	&llfmqstrngs [17],
	&llfmqstrngs [0],
	&llfmqstrngs [19],
	&llfmqstrngs [21],
	&llfmqstrngs [0],
	&llfmqstrngs [23],
	&llfmqstrngs [0],
};

/* Error Correction Strings */

short *llfmqE [] = {
	(short *) (-1),
	&llfmqstrngs [25],
	&llfmqstrngs [27],
	&llfmqstrngs [29],
	&llfmqstrngs [31],
	&llfmqstrngs [33],
	&llfmqstrngs [0],
	&llfmqstrngs [0],
	&llfmqstrngs [35],
	(short *) (-1),
	(short *) (-1),
	&llfmqstrngs [38],
	&llfmqstrngs [40],
	&llfmqstrngs [42],
	&llfmqstrngs [44],
	&llfmqstrngs [0],
	&llfmqstrngs [0],
	&llfmqstrngs [46],
	(short *) (-1),
	(short *) (-1),
	&llfmqstrngs [49],
	&llfmqstrngs [52],
	&llfmqstrngs [55],
	&llfmqstrngs [57],
	&llfmqstrngs [0],
	&llfmqstrngs [0],
	&llfmqstrngs [59],
	(short *) (-1),
	(short *) (-1),
	&llfmqstrngs [0],
	&llfmqstrngs [0],
	&llfmqstrngs [62],
	&llfmqstrngs [65],
	&llfmqstrngs [68],
	&llfmqstrngs [70],
	&llfmqstrngs [72],
	(short *) (-1),
	(short *) (-1),
	&llfmqstrngs [76],
	&llfmqstrngs [79],
	&llfmqstrngs [82],
	&llfmqstrngs [85],
	&llfmqstrngs [0],
	&llfmqstrngs [0],
	&llfmqstrngs [88],
	(short *) (-1),
	(short *) (-1),
	&llfmqstrngs [91],
	&llfmqstrngs [95],
	&llfmqstrngs [0],
	&llfmqstrngs [0],
	&llfmqstrngs [99],
	&llfmqstrngs [101],
	&llfmqstrngs [103],
};

#include	<stdio.h>

struct	treenode	{

	int	tp_op;
	struct	treenode	*tp_left;
	struct	treenode	*tp_right;
};

struct	treenode	*makopnode ();

char	*malloc ();

main()
{
	llparse();
}

llscan()
{
	register int c;
	int z;

	c = getc (stdin);

	while(1){
		switch(c){

		case EOF:
			return(lleof);


		case '\n':
			return(RETURN);


		case '\t':
		case ' ':
			c= getc (stdin); continue;


		case '+':
			return(PLUS);


		case '-':
			return(MINUS);


		case '*':
			return(MULT);


		case '/':
			return(DIV);


		case '(':
			return(LP);


		case ')':
			return(RP);

		default:
			if (c < '0' || c > '9') {
				printf("unknown char '%c'\n",c);
				c= getc (stdin); continue;
			}
			z= c - '0';
			while ((c= getc (stdin)) >= '0' && c <= '9')
				z= 10*z+c-'0';
			ungetc (c, stdin);
			llsyn(z);
			return(NUMBER);
		}
		}
}

_maknull ()

{
	llsyn (llinh ());
}

_makplus ()

{
	register	struct	treenode	*x, *y;

	x = (struct treenode *) llinh ();
	y = (struct treenode *) llinh ();

	llsyn ((int) makopnode (PLUS, x, y));
}

_makminus ()

{
	register	struct	treenode	*x, *y;

	x = (struct treenode *) llinh ();
	y = (struct treenode *) llinh ();

	llsyn ((int) makopnode (MINUS, x, y));
}

_makmult ()

{
	register	struct	treenode	*x, *y;

	x = (struct treenode *) llinh ();
	y = (struct treenode *) llinh ();

	llsyn ((int) makopnode (MULT, x, y));
}

_makdiv ()

{
	register	struct	treenode	*x, *y;

	x = (struct treenode *) llinh ();
	y = (struct treenode *) llinh ();

	llsyn ((int) makopnode (DIV, x, y));
}

_maknumber ()

{
	register	int	x;

	llsyn (makopnode (NUMBER, (struct treenode *) llinh (),
	(struct treenode *) 0));
}

struct treenode *
makopnode (op, left, right)

int	op;
struct	treenode	*left, *right;

{
	register	struct	treenode	*tp;

	if ((tp = (struct treenode *) malloc (sizeof (struct treenode))) == 
	(struct treenode *) 0) {
		fprintf (stderr, "Treenode allocation failure!\n");
		exit (1);
	}

	tp -> tp_op = op;
	tp -> tp_left = left;
	tp -> tp_right = right;

	return (tp);
}

_evaltree ()

{
	register	struct	treenode	*tp;

	tp = (struct treenode *) llinh ();
	evaluate (tp);
	freetree (tp);
}

evaluate (tp)

struct	treenode	*tp;

{
	switch (tp -> tp_op) {

	case NUMBER:
		printf ("Push %d\n", (int) tp -> tp_left);
		break;

	case PLUS:
	case MINUS:
	case MULT:
	case DIV:
		evaluate (tp -> tp_left);
		evaluate (tp -> tp_right);
		printop (tp -> tp_op);
		break;
	
	default:
		printf ("Bad operator: %d\n", tp -> tp_op);
		exit (2);
	}

	return;
}

printop (op)

int	op;

{
	char	*string;

	switch (op) {

	case PLUS:
		string = "Add";
		break;

	case MINUS:
		string = "Subtract";
		break;

	case MULT:
		string = "Multiply";
		break;

	case DIV:
		string = "Divide";
		break;
	}
	printf ("%s\n", string);
}

freetree (tp)

struct	treenode	*tp;

{
	switch (tp -> tp_op) {

	case PLUS:
	case MINUS:
	case MULT:
	case DIV:
		freetree (tp -> tp_left);
		freetree (tp -> tp_right);
		break;
	}
	free (tp);

	return;
}
