program:
	|	expr>x @print<x RETURN program ;

expr>v:		term>x terms<x>v ;

terms<x>v:	@echo<x>v
	|	PLUS term>y @add<x,y>z terms<z>v
	|	MINUS term>y @minus<x,y>z terms<z>v ;

term>v:		factor>x factors<x>v ;

factors<x>v:	@echo<x>v
	|	MULT factor>y @mult<x,y>z factors<z>v
	|	DIV factor>y @div<x,y>z factors<z>v ;

factor>v:	NUMBER>v
	|	LP expr>v RP ;

%
#include	<stdio.h>

main ()

{
	llparse ();
}

llscan ()

{
	register int c;
	int z;

	c = getc (stdin);

	while (1) {
		switch (c) {

		case EOF:
			return (lleof);

		case '\n':
			return (RETURN);

		case '\t':
		case ' ':
			c = getc (stdin);
			continue;

		case '+':
			return (PLUS);

		case '-':
			return (MINUS);

		case '*':
			return (MULT);

		case '/':
			return (DIV);

		case '(':
			return (LP);

		case ')':
			return (RP);

		default:
			if (c < '0' || c > '9') {
				printf ("unknown char '%c'\n",c);
				c = getc (stdin);
				continue;
			}

			z = c - '0';
			while ((c = getc (stdin)) >= '0' && c <= '9')
				z = 10 * z + c - '0';

			ungetc (c, stdin);
			llsyn (z);
			return (NUMBER);
		}
	}
}

_print ()

{
	printf ("%d\n",llinh ());
}

_add ()

{
	llsyn (llinh () + llinh ());
}

_minus ()

{
	int	x, y;

	x = llinh ();
	y = llinh ();
	llsyn (x - y);
}

_mult ()

{
	llsyn (llinh () * llinh ());
}

_div ()

{
	int	x, y;

	x = llinh ();
	y = llinh ();
	if (y)
		llsyn (x / y);
	else
		llsyn (0);
}

_echo ()

{
	llsyn (llinh ());
}
